/**
 * Saeki(Nekketu Saiten Kyousi Saeki)
 * (c) Kenta Cho (cs8k-cyu@asahi-net.or.jp)
 * http://www.asahi-net.or.jp/~cs8k-cyu/
 *
 * saeki.c(main routine)
 */

#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include "saeki.h"

int px[6], py[6], pid[6];
int lcXmin, lcXmax, lcYmin, lcYmax; 
int npid;

#include "drawpaper.c"
#include "gamemanager.c"

static int StartApplication(void) {
  randomize();
  initGame();
}

static void StopApplication(void) {
}

/**
 * check pen loucs is circle or check
 */
static void checkLocus() {
  int width, height;
  int i, j;
  int chkStt = 0;
  int rlCnt = 0, llCnt = 0;
  int pd = 0;
  int lcStat;
  width = (px[3] - px[1])/6;
  height = (py[4] - py[2])/6;
  if ( width < 3 ) width = 3;
  if ( height < 3 ) height = 3;
  lcXmin = px[1]; lcXmax = px[3];
  lcYmin = py[2]; lcYmax = py[4];

  for ( i=2 ; i<5 ; i++ ) {
    int tx = px[i], ty = py[i], tid = pid[i];
    for ( j=i ; j>1 ; j-- ) {
      if ( pid[j-1] < tid ) {
	break;
      } else {
	px[j] = px[j-1]; py[j] = py[j-1];
	pid[j] = pid[j-1];
      }
    }
    px[j] = tx; py[j] = ty; pid[j] = tid;
  }

  for ( i=0 ; i<5 ; i++ ) {
    int d = 0;
    int wd, ht;
    wd = abs(px[i] - px[i+1]);
    ht = abs(py[i] - py[i+1]);
    if ( wd > width ) {
      if ( ht > height/2 ) {
	if ( px[i] > px[i+1] ) {
	  if ( py[i] > py[i+1] ) d = 8;
	  else d = 6;
	} else {
	  if ( py[i] > py[i+1] ) d = 2;
	  else d = 4;
	}
      } else {
	if ( px[i] > px[i+1] ) d = 7;
	else d = 3;
      }
    } else {
      if ( ht > height ) {
	if ( wd > width/2 ) {
	  if ( px[i] > px[i+1] ) {
	    if ( py[i] > py[i+1] ) d = 8;
	    else d = 6;
	  } else {
	    if ( py[i] > py[i+1] ) d = 2;
	    else d = 4;
	  }
	} else {
	  if ( py[i] > py[i+1] ) d = 1;
	  else d = 5;
	}
      } else {
	d = 0;
      }
    }

    switch ( chkStt ) {
    case 0:
      if ( d==4 || d==5 || d==6 ) chkStt = 1;
      else if ( d != 0 ) chkStt = -1;
      break;
    case 1:
      if ( d == 2 ) chkStt = 2;
      break;
    case 2:
      if ( d > 3 ) chkStt = -1;
      break;
    }
    if ( d!=0 ) {
      if ( pd!=0 ) {
	int ds = pd - d;
	if ( (ds>0 && ds<4) || ds<-4 ) {
	  llCnt++; rlCnt = 0;
	} else if ( ds>4 || (ds>-4 && ds<0) ) {
	  rlCnt++; llCnt = 0;
	}
      }
      pd = d;
    }
  }
  if ( chkStt == 2 ) {
    lcStat = 1;
  } else if ( llCnt>=2 || rlCnt>=2 ) {
    lcStat = 0;
  } else {
    lcStat = 2;
  }
  locusDrawn(lcStat);
}

/*
 * handle pen locus
 */
int pvx, pvy;

static void setFirstPenPos(EventPtr event) {
  pvx = px[0] = px[1] = px[2] = px[3] = px[4] = event->screenX;
  pvy = py[0] = py[1] = py[2] = py[3] = py[4] = event->screenY;
  npid = 0;
  pid[0] = pid[1] = pid[2] = pid[3] = pid[4] = npid;
}

static void setEndPenPos(EventPtr event) {
  if ( npid < 0 || gameStatus.status != GAME_IN_PROGRESS ) return;
  px[5] = event->screenX;
  py[5] = event->screenY;
  pid[5] = npid;
  if ( pvy>=PEN_TOP_Y && pvy<PEN_BOTTOM_Y && 
       py[5]>=PEN_TOP_Y && py[5]<PEN_BOTTOM_Y ) {
    WinDrawLine(pvx, pvy, px[5], py[5]);
    WinDrawLine(pvx, pvy+1, px[5], py[5]+1);
  }
  checkLocus();
  npid = -1;
}

static void penMoved(int sx, int sy) {
  if ( npid < 0 || gameStatus.status != GAME_IN_PROGRESS ) return;
  if ( px[1] > sx ) {
    px[1] = sx; py[1] = sy;
    pid[1] = npid;
  }
  if ( py[2] > sy ) {
    px[2] = sx; py[2] = sy;
    pid[2] = npid;
  }
  if ( px[3] < sx ) {
    px[3] = sx; py[3] = sy;
    pid[3] = npid;
  }
  if ( py[4] < sy ) {
    px[4] = sx; py[4] = sy;
    pid[4] = npid;
  }
  npid++;
  if ( pvy>=PEN_TOP_Y && pvy<PEN_BOTTOM_Y && 
       sy>=PEN_TOP_Y && sy<PEN_BOTTOM_Y ) {
    WinDrawLine(pvx, pvy, sx, sy);
    WinDrawLine(pvx, pvy+1, sx, sy+1);
  }
  pvx = sx; pvy = sy;
}

static void handlePenMove(EventPtr event) {
  penMoved(event->screenX, event->screenY);
}

/**
 * event hanlder for title form
 */
static Boolean TitleFormHandleEvent(EventPtr event) {
  Boolean handled = FALSE;
  switch ( event->eType ) {
  case ctlSelectEvent:
    if ( event->data.ctlEnter.controlID == START_BUTTON ) {
      startButtonPushed();
      handled = TRUE;
    }
    break;
  case frmOpenEvent:
    FrmDrawForm(FrmGetActiveForm());
    drawTitle();
    npid = -1;
    handled = TRUE;
    break;
  }
  return handled;
}

/**
 * event hanlder for main form(saeki form)
 */
static Boolean MyFormHandleEvent(EventPtr event) {
  Boolean handled = FALSE;
  SWord px, py;
  Boolean pd;
  switch ( event->eType ) {
  case penDownEvent:
    setFirstPenPos(event);
    handled = TRUE;
    break;
  case penUpEvent:
    setEndPenPos(event);
    handled = TRUE;
    break;
  case penMoveEvent:
    handlePenMove(event);
    handled = TRUE;
    break;
  case frmOpenEvent:
    FrmDrawForm(FrmGetActiveForm());
    startGame();
    handled = TRUE;
    break;
  default:
    EvtGetPen(&px, &py, &pd);
    if ( npid!=-1 && pd && (pvx!=px || pvy!=py) ) {
      penMoved(px, py);
    }
    handled = TRUE;
    break;
  }
  return handled;
}

/**
 * activate forms
 */
static Boolean ApplicationHandleEvent(EventPtr event) {
  FormPtr frm;
  Int formID;
  Boolean handled = FALSE;

  if ( event->eType == frmLoadEvent ) {
    formID = event->data.frmLoad.formID;
    frm = FrmInitForm(formID);
    FrmSetActiveForm(frm);
    switch ( formID ) {
    case SAEKI_FORM:
      FrmSetEventHandler(frm, MyFormHandleEvent);
      break;
    case TITLE_FORM:
      FrmSetEventHandler(frm, TitleFormHandleEvent);
      break;
    }
    handled = TRUE;
  }
  return handled;
}

// event loop interval
#define INTERVAL 20

static void EventLoop(void) {
  EventType event;
  Word error;
  do {
    EvtGetEvent(&event, INTERVAL);
    if ( !SysHandleEvent(&event) ) {
      if ( !MenuHandleEvent(0, &event, &error) ) {
	if ( !ApplicationHandleEvent(&event) ) {
	  FrmDispatchEvent(&event);
	}
      }
    }
    handleGameStatus();
  } while ( event.eType != appStopEvent );
}

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags) {
  if ( cmd != sysAppLaunchCmdNormalLaunch ) return 0;
  StartApplication();
  EventLoop();
  StopApplication();
  return 0;
} 
